import { DOMWidgetModel, DOMWidgetView } from "@jupyter-widgets/base";
declare type DocsJson = any;
declare type RenderItem = any;
declare type DocumentChangedEvent = any;
declare type Fragment = any;
export declare type RenderBundle = {
    docs_json: DocsJson;
    render_items: RenderItem[];
    div: string;
};
export interface DocumentChanged {
    event: "jsevent";
    kind: string;
}
export interface ModelChanged extends DocumentChanged {
    event: "jsevent";
    kind: "ModelChanged";
    id: string;
    new: unknown;
    attr: string;
    old: unknown;
    hint: unknown;
}
export interface MessageSent extends DocumentChanged {
    event: "jsevent";
    kind: "MessageSent";
    msg_data: {
        event_name: string;
        event_values: {
            model: {
                id: string;
            };
            [other: string]: any;
        };
    };
    msg_type: string;
}
export declare class BokehModel extends DOMWidgetModel {
    defaults(): any;
    static serializers: {
        [x: string]: {
            deserialize?: ((value?: any, manager?: import("@jupyter-widgets/base").ManagerBase<any> | undefined) => any) | undefined;
            serialize?: ((value?: any, widget?: import("@jupyter-widgets/base").WidgetModel | undefined) => any) | undefined;
        };
    };
}
export declare class BokehView extends DOMWidgetView {
    private _document;
    private _receiver;
    private _blocked;
    private _msgs;
    private _idle;
    private _combine;
    constructor(options?: any);
    protected _process_msg(): void;
    render(): void;
    _combine_events(new_msg: (ModelChanged | MessageSent)): (ModelChanged | MessageSent)[];
    _send(msg: (ModelChanged | MessageSent)): void;
    protected _change_event(event: DocumentChangedEvent): void;
    protected _consume_patch(content: {
        msg: "patch";
        payload?: Fragment;
    }, buffers: DataView[]): void;
}
export {};
